#-*- coding:utf-8 -*-

#    Gedit html_escape plugin version 3.20.0
#    Copyright © 2011-2013 sasakima-nao <sasakimanao@gmail.com>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    2016.06.23 Version 3.20.0
#    Support Gedit 3.20
#    remove '_' of action_name
#    'GObject.property' to 'GObject.Property'
#    append 'Plugin' in class name
#
#    2015.11.08 Version 3.18.0
#    Support Gedit 3.18
#    Add gi.require_version
#
#    2014.11.17 Version 3.12.0
#    Support Gedit 3.12
#
#    2013.11.03 Version 3.1.0
#    Support Gedit 3.8 (Python3)
#
#    2011.06.04 Version 3.0.0

import gi
gi.require_version("Gtk", "3.0")
gi.require_version("Gedit", "3.0")
gi.require_version("Peas", "1.0")

from gi.repository import GObject, Gedit, Gtk, Gio

class HtmlEscapeAppActivatable(GObject.Object, Gedit.AppActivatable):
    """
        Set GMenu and Accelerator
    """
    app = GObject.Property(type=Gedit.App)
 
    def __init__(self):
        GObject.Object.__init__(self)
 
    def do_activate(self):
        self.app.add_accelerator("<Control><Shift>E", "win.htmlescape", None)
        self.menu_ext = self.extend_menu("tools-section")
        item = Gio.MenuItem.new("HTML エスケイプ",  "win.htmlescape")
        self.menu_ext.append_menu_item(item)
 
    def do_deactivate(self):
        self.app.remove_accelerator("win.htmlescape", None)

class HtmlEscapePlugin(GObject.Object, Gedit.WindowActivatable):
    __gtype_name__ = "HtmlEscapePlugin"
    window = GObject.Property(type=Gedit.Window)
    def __init__(self):
        GObject.Object.__init__(self)

    def do_activate(self):
        self.action = Gio.SimpleAction.new("htmlescape", None)
        self.action.connect('activate', self.on_htmlescape_activate)
        self.window.add_action(self.action)

    def do_deactivate(self):
        self.window.remove_action("htmlescape")

    def do_update_state(self):
        self.action.set_enabled(self.window.get_active_document() != None)

    def on_htmlescape_activate(self, action, param):
        view = self.window.get_active_view()
        buf = view.get_buffer()
        try:
            begin, end = buf.get_selection_bounds()
        except:
            self.messagebox("変換したいテキストを選択してください")
            return
        text = begin.get_text(end)
        result = ""
        for s in text:
            if s == "<":
                s = "&lt;"
            elif s == ">":
                s = "&gt;"
            elif s == "&":
                s = "&amp;"
            result += s
        buf.delete_selection(True, True)
        buf.insert_at_cursor(result)

    def messagebox(self, text):
        dlg = Gtk.MessageDialog(
                self.window,
                Gtk.DialogFlags.MODAL,
                Gtk.MessageType.WARNING,
                Gtk.ButtonsType.OK,
                text)
        r = dlg.run()
        dlg.destroy()
